﻿using System;
using System.Collections.Generic;
using Microsoft.Extensions.DependencyInjection;

namespace Common.Core.IoC
{
    public class ServiceProviderWrapper : IContainer
    {
        private readonly IServiceProvider serviceProvider;

        public ServiceProviderWrapper(IServiceProvider serviceProvider)
        {
            this.serviceProvider = serviceProvider;
        }

        public IEnumerable<TService> GetAllInstances<TService>() where TService : class
        {
            return serviceProvider.GetServices<TService>();
        }

        public object GetInstance(Type serviceType)
        {
            return serviceProvider.GetService(serviceType);
        }

        public TService GetInstance<TService>() where TService : class
        {
            return serviceProvider.GetService<TService>();
        }
    }
}